// EmiDlg.h : wb_[ t@C
//

#if !defined(AFX_EMIDLG_H__6D6682E6_890A_11D4_BF59_00C026A5008F__INCLUDED_)
#define AFX_EMIDLG_H__6D6682E6_890A_11D4_BF59_00C026A5008F__INCLUDED_

#include "SpiUnit.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Bmp.h"
#include "SArray.h"

/////////////////////////////////////////////////////////////////////////////
// CEmiDlg _CAO

class SSTRARRAY;

class CEmiDlg : public CDialog
{
// \z
public:
	void DoDispatchWindowsMessage();
	BOOL m_bOnDeleteSmall;
	void EnableControls( BOOL bSw );
	int DoDeleteSmallRecursive( BOOL bDoMove );
	int DoDeleteSmall();
	CString GetFullPath();
	void WalkOutDirectory();
	void WalkInDirectory();
	BOOL CursorToLower();
	BOOL m_bAutoRenameAtMove;
	CString SelectFolder( const CString& strCurrent , const CString& strExp );
	CString m_strURLMemo;
	CString m_strURLProgram;
	CString m_strOpenWindowProgram;
	CString GetIniPath();
	void OnJump();
	CString m_strWallPaperDir;
	BOOL SaveWallPaper( BOOL bChangeWallPaper , const char* pFName = NULL );
	void DeleteViewingItemFromFileList();
	void LayoutObjects();
	BOOL m_bStretch;
	RECT AdjustRect( LPRECT pSrcRect,LPRECT pDstRect );
	void DrawScreen( CDC* pDC,BOOL bReDrawBack=TRUE,CSpiUnit* pSpiUnit=NULL );
	int m_iViewingIndex;
	SCLASSARRAY< CSpiUnit > m_aSpiUnit;
	void MapSPI();
	CString ChangeDirectory();
	void LoadFileList( CString& strBasePath );
	void DrawDirTopPicture(); 
	BOOL PictureOffset( int dx , int dy );
	CBmp m_Bmp;
	CEmiDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CEmiDlg)
	enum { IDD = IDD_EMI_DIALOG };
	CButton	m_btnChangeDir;
	CListBox	m_lbFileList;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CEmiDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	int m_iDeleteSmallHeight;
	int m_iDeleteSmallWidth;
	BOOL m_bResizeWallPaperToScreenSize;
	BOOL m_bDeleteImmediate;
	void ReloadFileList();
	BOOL DeletePictureFile();
	BOOL DeleteSmallPicture();
	BOOL DeleteDir();
	BOOL DoDeleteDirectory( CString strPath , BOOL bForce = FALSE );
	BOOL IsDir();
	BOOL IsPictureReady();
	CString GetDirName();
	CSpiUnit* GetSelectedSPIUnit();
	BOOL CopyPictureFile();
	BOOL TrashPictureFile();
	BOOL MovePictureFile();
	CString m_strMoveDir;
	CString m_strCopyDir;
	CString m_strTrashDir;
	BOOL m_bLayoutReady;
	long m_lOffsetY;
	long m_lOffsetX;
	SSTRARRAY m_straFileType;
	CString m_strBasePath;
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CEmiDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnChangedir();
	afx_msg void OnSelchangeFilelist();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnPreference();
	afx_msg void OnAboutbox();
	afx_msg void OnExit();
	afx_msg void OnSmallRange();
	afx_msg void OnDeleteSmall();
	afx_msg void OnViewHelp();
	afx_msg void OnDeleteSmallRecursive();
	afx_msg void OnDeleteSmallRecursiveWithMove();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void RenameFile();
	void OpenIExplore();
	void OpenExplore();
	void ChangeMoveDir();
	void ChangeTrashDir();
	void ChangeCopyDir();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_EMIDLG_H__6D6682E6_890A_11D4_BF59_00C026A5008F__INCLUDED_)
