// Preference.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Emi.h"
#include "Preference.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreference _CAO


CPreference::CPreference(CWnd* pParent /*=NULL*/)
	: CDialog(CPreference::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPreference)
	m_bDeleteImmediate = TRUE;
	m_strMoveDir = _T("");
	m_strTrashDir = _T("");
	m_strCopyDir = _T("");
	m_strWallPaperDir = _T("");
	m_bResizeToScreenSize = FALSE;
	m_strOpenWindowProgram = _T("");
	m_strURLMemo = _T("");
	m_strURLProgram = _T("");
	m_bAutoRenameAtMove = FALSE;
	//}}AFX_DATA_INIT
}


void CPreference::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreference)
	DDX_Check(pDX, IDC_DELETEIMMEDIATE, m_bDeleteImmediate);
	DDX_Text(pDX, IDC_MOVEDIR, m_strMoveDir);
	DDX_Text(pDX, IDC_TRASHDIR, m_strTrashDir);
	DDX_Text(pDX, IDC_COPYDIR, m_strCopyDir);
	DDX_Text(pDX, IDC_WALLPAPERDIR, m_strWallPaperDir);
	DDX_Check(pDX, IDC_RESIZETOSCREENSIZE, m_bResizeToScreenSize);
	DDX_Text(pDX, IDC_WINDOW_EDIT, m_strOpenWindowProgram);
	DDX_Text(pDX, IDC_URLMEMO_EDIT, m_strURLMemo);
	DDX_Text(pDX, IDC_URL_EDIT, m_strURLProgram);
	DDX_Check(pDX, IDC_AUTO_RENAME_AT_MOVE, m_bAutoRenameAtMove);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreference, CDialog)
	//{{AFX_MSG_MAP(CPreference)
	ON_BN_CLICKED(IDC_REFFER_MOVEDIR, OnRefferMovedir)
	ON_BN_CLICKED(IDC_REFFER_TRASHDIR, OnRefferTrashdir)
	ON_BN_CLICKED(IDC_REFFER_COPYDIR, OnRefferCopydir)
	ON_BN_CLICKED(IDC_REFFER_WALLPAPERDIR, OnRefferWallpaperdir)
	ON_BN_CLICKED(IDC_REFFER_WINDOW, OnRefferWindow)
	ON_BN_CLICKED(IDC_REFFER_URL, OnRefferUrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreference bZ[W nh

//-----------------------------------------------< ړfBNgQ >
void CPreference::OnRefferMovedir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// BROWSEINFO 
	BROWSEINFO	sBI;
	sBI.hwndOwner		= GetSafeHwnd();
    sBI.pidlRoot		= NULL;
    sBI.pszDisplayName	= cDirName;
    sBI.lpszTitle		= "ړfBNgI\n'M'L[ƁAt@C̃fBNgɈړ܂B";
    sBI.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS;
    sBI.lpfn			= CPreference::BrowseCallbackProc;
    sBI.lParam			= (long)( (LPCTSTR)m_strMoveDir );
    sBI.iImage			= NULL;

	// fBNgI_CAO\
	LPITEMIDLIST lpRes;									// SHBrowseForFolder̖߂l
	CString		 strRes;								// ʂ̃fBNg
	lpRes = SHBrowseForFolder( &sBI );

	// ʂ̃fBNgݒ
	if( lpRes==NULL ){
		strRes = m_strMoveDir;
	} else {
		SHGetPathFromIDList( lpRes,cDirName );
		strRes = CString( cDirName );
	}
	m_strMoveDir = strRes;

	// GfBbg{bNXύX
	CEdit* pEdit;
	pEdit = (CEdit*)GetDlgItem( IDC_MOVEDIR );
	pEdit->SetWindowText( (LPCTSTR)m_strMoveDir );

}


//-----------------------------------------------< TrashfBNgQ >
void CPreference::OnRefferTrashdir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// BROWSEINFO 
	BROWSEINFO	sBI;
	sBI.hwndOwner		= GetSafeHwnd();
    sBI.pidlRoot		= NULL;
    sBI.pszDisplayName	= cDirName;
    sBI.lpszTitle		= "TRASHfBNgI\n'T'L[ƁAt@C̃fBNgɈړ܂B";
    sBI.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS;
    sBI.lpfn			= CPreference::BrowseCallbackProc;
    sBI.lParam			= (long)( (LPCTSTR)m_strTrashDir );
    sBI.iImage			= NULL;

	// fBNgI_CAO\
	LPITEMIDLIST lpRes;									// SHBrowseForFolder̖߂l
	CString		 strRes;								// ʂ̃fBNg
	lpRes = SHBrowseForFolder( &sBI );

	// ʂ̃fBNgݒ
	if( lpRes==NULL ){
		strRes = m_strTrashDir;
	} else {
		SHGetPathFromIDList( lpRes,cDirName );
		strRes = CString( cDirName );
	}
	m_strTrashDir = strRes;

	// GfBbg{bNXύX
	CEdit* pEdit;
	pEdit = (CEdit*)GetDlgItem( IDC_TRASHDIR );
	pEdit->SetWindowText( (LPCTSTR)m_strTrashDir );

}


//-----------------------------------------------< Rs[fBNgQ >
void CPreference::OnRefferCopydir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// BROWSEINFO 
	BROWSEINFO	sBI;
	sBI.hwndOwner		= GetSafeHwnd();
    sBI.pidlRoot		= NULL;
    sBI.pszDisplayName	= cDirName;
    sBI.lpszTitle		= "Rs[fBNgI\n'C'L[ƁAt@C̃fBNgɃRs[܂B";
    sBI.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS;
    sBI.lpfn			= CPreference::BrowseCallbackProc;
    sBI.lParam			= (long)( (LPCTSTR)m_strCopyDir );
    sBI.iImage			= NULL;

	// fBNgI_CAO\
	LPITEMIDLIST lpRes;									// SHBrowseForFolder̖߂l
	CString		 strRes;								// ʂ̃fBNg
	lpRes = SHBrowseForFolder( &sBI );

	// ʂ̃fBNgݒ
	if( lpRes==NULL ){
		strRes = m_strCopyDir;
	} else {
		SHGetPathFromIDList( lpRes,cDirName );
		strRes = CString( cDirName );
	}
	m_strCopyDir = strRes;

	// GfBbg{bNXύX
	CEdit* pEdit;
	pEdit = (CEdit*)GetDlgItem( IDC_COPYDIR );
	pEdit->SetWindowText( (LPCTSTR)m_strCopyDir );

}

//-----------------------------------------------< ǎfBNgQ >
void CPreference::OnRefferWallpaperdir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// BROWSEINFO 
	BROWSEINFO	sBI;
	sBI.hwndOwner		= GetSafeHwnd();
    sBI.pidlRoot		= NULL;
    sBI.pszDisplayName	= cDirName;
    sBI.lpszTitle		= "ǎۑfBNgI\n'W'L[ƁAt@C̃fBNgɂalo쐬܂B";
    sBI.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS;
    sBI.lpfn			= CPreference::BrowseCallbackProc;
    sBI.lParam			= (long)( (LPCTSTR)m_strWallPaperDir );
    sBI.iImage			= NULL;

	// fBNgI_CAO\
	LPITEMIDLIST lpRes;									// SHBrowseForFolder̖߂l
	CString		 strRes;								// ʂ̃fBNg
	lpRes = SHBrowseForFolder( &sBI );

	// ʂ̃fBNgݒ
	if( lpRes==NULL ){
		strRes = m_strWallPaperDir;
	} else {
		SHGetPathFromIDList( lpRes,cDirName );
		strRes = CString( cDirName );
	}
	m_strWallPaperDir = strRes;

	// GfBbg{bNXύX
	CEdit* pEdit;
	pEdit = (CEdit*)GetDlgItem( IDC_WALLPAPERDIR );
	pEdit->SetWindowText( (LPCTSTR)m_strWallPaperDir );
}

//-----------------------------------------------< WindowI[vvOQ >
void CPreference::OnRefferWindow() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// t@CI
	CFileDialog objDialog( TRUE , NULL , this->m_strOpenWindowProgram , OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR );
	int iResult;
	iResult = objDialog.DoModal();
	if( iResult!=IDOK ){
		return;
	}

	// fBNgI_CAO\
	CString		 strRes;								// ʂ̃pX
	strRes = objDialog.GetPathName();

	// ʐݒ
	m_strOpenWindowProgram = strRes;

	// GfBbg{bNXύX
	CEdit* pEdit;
	pEdit = (CEdit*)GetDlgItem( IDC_WINDOW_EDIT );
	pEdit->SetWindowText( (LPCTSTR)m_strOpenWindowProgram );
	
}

//-----------------------------------------------< URL\vOQ >
void CPreference::OnRefferUrl() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// t@CI
	CFileDialog objDialog( TRUE , NULL , this->m_strURLProgram , OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR );
	int iResult;
	iResult = objDialog.DoModal();
	if( iResult!=IDOK ){
		return;
	}

	// fBNgI_CAO\
	CString		 strRes;								// ʂ̃pX
	strRes = objDialog.GetPathName();

	// ʐݒ
	m_strOpenWindowProgram = strRes;

	// GfBbg{bNXύX
	CEdit* pEdit;
	pEdit = (CEdit*)GetDlgItem( IDC_URL_EDIT );
	pEdit->SetWindowText( (LPCTSTR)m_strOpenWindowProgram );
}

//-----------------------------------------------< _CAO >
BOOL CPreference::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//-----------------------------------------------< tH_IfBNg R[obN >
int CALLBACK CPreference::BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
	if(uMsg==BFFM_INITIALIZED){
		::SendMessage(hwnd,BFFM_SETSELECTION,(WPARAM)TRUE,lpData);
	}
	return 0;
}
