#ifndef __SPIUNIT_H__
#define __SPIUNIT_H__

// ----------< 萔` >----------
#define _MAX_TYPEEXT	10		// PSPIɑΉgq̎ނ̍ő吔


// ----------< \̒` >----------
// 摜\
typedef struct PictureInfo
{
	long	left,top;			// 摜WJʒu
	long	width;				// 摜̕(pixel)
	long	height;				// 摜̍(pixel)
	WORD	x_density;			// f̐x
	WORD	y_density;			// f̐x
	short	colorDepth;			// Pfbit
	HLOCAL	hInfo;				// 摜̃eLXg
}PictureInfo;


// ----------< ֐ւ̃|C^̌^` >----------

typedef	int (PASCAL *GetPluginInfo)(	// vOC̏Ԃ
				 int infono,LPSTR buf,int buflen );

typedef	int (PASCAL *IsSupported)(		// T|[gĂt@CǂԂ
				 LPSTR filename,DWORD dw );

typedef	int (PASCAL *GetPictureInfo)(	// 摜̏Ԃ
				LPSTR buf,long len,unsigned int flag,struct PictureInfo *lpInfo );

typedef	int (PASCAL *GetPicture)(		// 摜擾
				 LPSTR buf,long len,unsigned int flag,HANDLE *pHBInfo,HANDLE *pHBm
				,FARPROC lpPrgressCallback,long lData);

typedef	int (PASCAL *GetPreview)(		// vr[摜擾
				 LPSTR buf,long len,unsigned int flag,HANDLE *pHBInfo,HANDLE *pHBm
				,FARPROC lpPrgressCallback,long lData);



//------------------------------------------------< roh𐧌䂷NX >
//
class CSpiUnit
{
	// \z
	public:
		CSpiUnit();										// RXgN^
		CSpiUnit( CSpiUnit& refSpiUnit );				// Rs[RXgN^
		virtual ~CSpiUnit();							// fXgN^
		CSpiUnit& operator=( CSpiUnit& refSpiUnit );	// = Zq

	// f[^o
	protected:
		HMODULE		m_hSpi;								// DLL(SPI)̃nh
		char*		m_pSpiPath;							// DLL(SPI)ւ̃pX
		char		m_cFileName[_MAX_PATH];				// ݓǂݍ܂Ă摜t@C̃pX
		int			m_iTypeNum;							// ΉĂgq̐
														// gqz
		char		m_aTypeExtension[_MAX_TYPEEXT][_MAX_PATH];

		PictureInfo	m_sPictureInfo;						// 摜\
		HLOCAL		m_hBmpInfo;							// BMPINFO i[郁̃nh
		HLOCAL		m_hBmpBits;							// rbgzi[郁̃nh

	// o֐
	public:
		// SPĨ}bsO֘A
		BOOL	Load( char* pSpiPath );					// SPIɃ}bv
		void	Free();									// SPI

		// gq֘A
		BOOL	IsType( const char* pExt );				// ΉĂgqǂ
		int		GetTypeNum();							// ΉĂgq̐
		char*	GetTypeExtension( int iIndex );			// ΉĂgq̎擾

		// 摜荞݊֘A
		BOOL	LoadPicture( const char* pFName );		// 摜t@C̓ǂݍ
		void	FreePicture();							// 摜̔j

		// 摜ۑ֘A
		BOOL SaveAsWallPaper( const char* pFName,BOOL bStretch=FALSE );
		BOOL SaveBMP( const char* pFName );

		// 摜擾
		long	GetWidth();								// Ԃ
		long	GetHeight();							// Ԃ

		// `֘A
		BOOL	NormalDraw(								// t@Cǂݍ݁A摜\
			char* pFName,HDC hDC,int iX=0,int iY=0);
		BOOL	NormalDraw(								// ɓǂݍ񂾃t@C`悷
			HDC hDC,int iX=0,int iY=0);
		BOOL	StretchDraw(							// t@Cǂݍ݁A摜\
			char* pFName,HDC hDC,LPRECT pSrcRect,LPRECT pDstRect );
		BOOL	StretchDraw(							// ɓǂݍ񂾃t@C`悷
			HDC hDC,LPRECT pSrcRect,LPRECT pDstRect );
};

#endif
