//
//  CBmpNX
//

#include "Bmp.h"


//------------------------------------------------<< ftHgRXgN^ >>
CBmp::CBmp()
{
	m_isSet				= FALSE;			// f[^̓ZbgĂȂB
	m_isBitOperating	= FALSE;			// rbgz̑쒆ł͂Ȃ
}


//------------------------------------------------<< t@CwRXgN^ >>
CBmp::CBmp( LPCTSTR pFName,CDC* pDC )
{
	CBmp::CBmp();						// ftHgRXgN^̏s
	Load( pFName,pDC );					// 摜ǂݍ
}


//------------------------------------------------<< TCYArbgkxwRXgN^ >>
CBmp::CBmp( int iSizeX , int iSizeY , int iBitDepth , CDC* pDC )
{
	// < ftHg̏s >
	CBmp::CBmp();

	// <  >
	BOOL bRes;
	bRes = Initialize( iSizeX,iSizeY,iBitDepth,pDC );
}


//------------------------------------------------<< fXgN^ >>
CBmp::~CBmp()										// fXgN^
{
	Free();								// ̉
}


//------------------------------------------------<< t@CwŁAf[^[h >>
BOOL CBmp::Load( LPCTSTR pFName,CDC* pDC )
{
	// < f[^ǂݍ܂ĂꍇA܂j >
	Free();

	// < wb_֘Ȁ >
	BOOL	bResult;							// u[lł̌ʊi[
	DWORD	dwRead;
	HANDLE	hFile;								// t@Cnh

	// < t@CI[v >
	hFile = CreateFile( pFName,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL );
	if( hFile==INVALID_HANDLE_VALUE )return FALSE;					// t@CI[vs

	// < rbg}bvt@Cwb_ǂݍ >
	dwRead	= 0;
	bResult	= ReadFile( hFile,&m_bmfh,sizeof( BITMAPFILEHEADER ),&dwRead,NULL );
	if( bResult==FALSE||m_bmfh.bfType!=0x4D42 ){	// rbg}bvt@CȂHI
		CloseHandle(hFile);
		return FALSE;
	}

	// < rbg}bvCtHwb_ǂݍ >
	if( ReadFile( hFile,&m_bmih,sizeof( BITMAPINFOHEADER ),&dwRead,NULL )==FALSE ){
		CloseHandle( hFile );
		return FALSE;							// CtHwb_ǂ߂ȂHI
	}

	// < pbg֘Ȁ >
	UINT uColors;								// F

	if( m_bmih.biClrUsed!=0 )uColors = m_bmih.biClrUsed;
	else uColors = ( 1<<m_bmih.biBitCount );

	// < pbgCfbNX̏ꍇ >
	if( m_bmih.biBitCount<24 ){
		m_isFullColor		= FALSE;			// tJ[Ȃ
		m_lpbmi				= (LPBITMAPINFO)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT
								,sizeof( BITMAPINFOHEADER )+sizeof( RGBQUAD )*uColors);
		m_lpbmi->bmiHeader	= m_bmih;
		if( ReadFile( hFile,&(m_lpbmi->bmiColors),sizeof( RGBQUAD )*uColors,&dwRead,NULL )==FALSE ){
			CloseHandle( hFile );
			GlobalFree( (HGLOBAL)m_lpbmi );
			return FALSE;
		}
	}
	// < tJ[̏ꍇ >
	else {
		m_isFullColor		= TRUE;				// tJ[
		m_lpbmi				= (LPBITMAPINFO)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT
								,sizeof( BITMAPINFOHEADER )+sizeof( RGBQUAD ));
		m_lpbmi->bmiHeader	= m_bmih;
	}



	// < nh̍쐬 >
	UINT uSizeImage;												// TCYvZ
	uSizeImage = GetWidthByte()*m_bmih.biHeight;
	m_lpBits=(void*)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT,uSizeImage );

	if( ReadFile( hFile,m_lpBits,uSizeImage,&dwRead,NULL )==FALSE ){	// f[^ǂݍ
		CloseHandle( hFile );					// t@Cnh
		GlobalFree( m_lpBits );					// DIBobt@
		GlobalFree( (HGLOBAL)m_lpbmi );			// 
		return FALSE;
	}
														// nh쐬
	m_hBmp = CreateDIBitmap( pDC->m_hDC,&m_bmih,CBM_INIT,m_lpBits,m_lpbmi,DIB_RGB_COLORS );
	if( m_hBmp==NULL ){							// sI
		CloseHandle( hFile );					// t@Cnh
		GlobalFree( m_lpBits );					// DIBobt@
		GlobalFree( (HGLOBAL)m_lpbmi );			// 
		return FALSE;
	}
	CloseHandle( hFile );						// t@CN[Y


	// < pbgnh쐬 >
	if( !m_isFullColor ){						// tJ[Ȃꍇ̂݁B
		m_lpLogPal = (LPLOGPALETTE)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT
						,sizeof( LOGPALETTE )+sizeof( PALETTEENTRY )*uColors );

		m_lpLogPal->palVersion		= 0x300;
		m_lpLogPal->palNumEntries	= uColors;
		for( UINT i=0;i<uColors;i++ ){
			m_lpLogPal->palPalEntry[i].peRed	= m_lpbmi->bmiColors[i].rgbRed;
			m_lpLogPal->palPalEntry[i].peGreen	= m_lpbmi->bmiColors[i].rgbGreen;
			m_lpLogPal->palPalEntry[i].peBlue	= m_lpbmi->bmiColors[i].rgbBlue;
		}

		m_hPal = CreatePalette( m_lpLogPal );	// pbgnh쐬
	}

	// <  >
	m_isSet	= TRUE;					// Zbg
	return TRUE;					// I
}


//---------------------------------------------------<< TCYArbg[xw̃CjVCU >>
BOOL CBmp::Initialize( int iSizeX , int iSizeY , int iBitDepth , CDC* pDC )
{
	Free();
	m_isSet = FALSE;					// Ƃ肠...

	// < rbgz̃TCYvZ >
	UINT uSizeImage;
	uSizeImage  = ( iSizeX*iBitDepth )/8;			// oCg
	uSizeImage += ( 4-(uSizeImage&3) )&3;			// SoCgE
	uSizeImage *= iSizeY;							// đŜ̃TCY


	// < Bitmap File Header 쐬 >
	UINT uColors = 1<<iBitDepth;
	UINT uQuadSize;
	if( iBitDepth>=24 )uQuadSize = 0;
	else uQuadSize=sizeof(RGBQUAD)*uColors;

	m_bmfh.bfType		= 0x4d42;
	m_bmfh.bfSize		= sizeof( BITMAPINFOHEADER )+sizeof( BITMAPFILEHEADER )
							+uQuadSize+uSizeImage;
	m_bmfh.bfReserved1	= 0;
	m_bmfh.bfReserved2	= 0;
	m_bmfh.bfOffBits	= sizeof( BITMAPINFOHEADER )
							+sizeof( BITMAPFILEHEADER )+uQuadSize;

	// < Bitmap Info Header 쐬 >
	m_bmih.biSize				= sizeof( BITMAPINFOHEADER );
	m_bmih.biWidth			= iSizeX;
	m_bmih.biHeight			= iSizeY;
	m_bmih.biPlanes			= 1;
	m_bmih.biBitCount			= iBitDepth;
	m_bmih.biCompression		= 0;
	m_bmih.biSizeImage		= uSizeImage;
	m_bmih.biXPelsPerMeter	= 0;
	m_bmih.biYPelsPerMeter	= 0;
	m_bmih.biClrUsed			= 0;
	m_bmih.biClrImportant		= 0;

	// < tJ[ǂ >
	if( iBitDepth>=24 )m_isFullColor = TRUE;
	else m_isFullColor = FALSE;


	// < BITMAPINFO 쐬 >
	if( m_bmih.biClrUsed!=0 )uColors = m_bmih.biClrUsed;
	else uColors = (1 << m_bmih.biBitCount);

	if( m_bmih.biBitCount<24 ){					// tJ[łȂꍇ
		m_lpbmi = (LPBITMAPINFO)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT
						,sizeof( BITMAPINFOHEADER )+sizeof( RGBQUAD )*uColors );
		m_lpbmi->bmiHeader = m_bmih;
	} else {									// tJ[̏ꍇ
		m_lpbmi=(LPBITMAPINFO)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT
						,sizeof( BITMAPINFOHEADER )+sizeof( RGBQUAD ));
		m_lpbmi->bmiHeader = m_bmih;
	}


	// < nh̍쐬 >
	// rbgz񏉊
	m_lpBits = (void*)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT,uSizeImage );
	memset( m_lpBits , 0 , uSizeImage );

	// rbg}bvnh쐬
	m_hBmp = CreateDIBitmap( pDC->m_hDC,&m_bmih,CBM_INIT,m_lpBits,m_lpbmi,DIB_RGB_COLORS );
	if( m_hBmp==NULL ){										// sI
		GlobalFree( m_lpBits );								// DIBobt@
		GlobalFree( (HGLOBAL)m_lpbmi );						// 
		m_isSet = FALSE;									// ZbgĂȂ
		return FALSE;
	}

	// < pbgnh쐬 >
	if( !m_isFullColor ){									// tJ[Ȃꍇ̂݁B
		m_lpLogPal = (LPLOGPALETTE)GlobalAlloc( GMEM_DISCARDABLE|GMEM_ZEROINIT
							,sizeof(LOGPALETTE)+sizeof(PALETTEENTRY)*uColors );

		m_lpLogPal->palVersion		= 0x300;
		m_lpLogPal->palNumEntries	= uColors;
		for( UINT i=0;i<uColors;i++ ){
			m_lpLogPal->palPalEntry[i].peRed	= m_lpbmi->bmiColors[i].rgbRed;
			m_lpLogPal->palPalEntry[i].peGreen	= m_lpbmi->bmiColors[i].rgbGreen;
			m_lpLogPal->palPalEntry[i].peBlue	= m_lpbmi->bmiColors[i].rgbBlue;
		}

		m_hPal = CreatePalette( m_lpLogPal );				// pbgnh쐬
	}

	m_isSet = TRUE;											// Zbg
	return TRUE;											// I
}


//------------------------------------------------<< 摜Z[u >>
BOOL CBmp::Save( LPCTSTR pFName )
{
	// G[`FbN
	if( isReady()==FALSE )return FALSE;				// 摜łĂȂ΃G[


	// t@CI[v
	FILE *stream;									// t@CXg[
	stream = fopen( pFName,"wb" );					// t@CI[v
	if( stream==NULL )return FALSE;					// I[vłȂꍇ


	// 
	fwrite( GetBMFH(),sizeof(BITMAPFILEHEADER),1,stream );	// BITMAPFILEHEADER
	fwrite( GetBMIH(),sizeof(BITMAPINFOHEADER),1,stream );	// BITMAPINFOHEADER
	if( GetColorDepth()<24 ){								// CfbNXJ[̏ꍇ
		// RGBQUADo
		RGBQUAD	quad;
		UINT	uColors;
		uColors = (1<<GetColorDepth());						// FvZ
		for( UINT i=0;i<uColors;i++ ){
			quad = GetPalet( i );							// pbg擾
			fwrite( &quad,sizeof( RGBQUAD ),1,stream );		// 
		}
	}

	UINT uSizeImage;										// rbgz̃TCYvZ
	uSizeImage = GetWidthByte()*GetHeight();
	fwrite( m_lpBits,uSizeImage,1,stream );					// rbgz񏑂

	fclose( stream );										// t@CN[Y

	return TRUE;											// I
}


//------------------------------------------------<< ǎp摜Z[u >>
BOOL CBmp::SaveAsWallPaper( LPCTSTR pFName, BOOL bStretch )
{
	// G[`FbN
	if( isReady()==FALSE )return FALSE;				// 摜łĂȂ΃G[


	// ʂ̃TCY擾
	int	iScreenWidth;
	int	iScreenHeight;
	iScreenWidth	= GetSystemMetrics( SM_CXSCREEN );
	iScreenHeight	= GetSystemMetrics( SM_CYSCREEN );

	// AXyNg(Width/Height) * 10000 擾
	int iScreenARatio;
	iScreenARatio	= ( iScreenWidth*10000 ) / iScreenHeight;

	// 摜̃TCY擾
	int iPictureWidth;
	int iPictureHeight;
	iPictureWidth	= GetWidth();
	iPictureHeight	= GetHeight();

	// AXyNg(Width/Height) * 10000 擾
	int iPictureARatio;
	iPictureARatio	= ( iPictureWidth * 10000 ) / iPictureHeight;

	// o͉摜TCYvZ
	int iBmpWidth;
	int	iBmpHeight;

	if( iPictureARatio > iScreenARatio ){	// XN[摜̕ɒꍇ
		iBmpWidth	= iPictureWidth;		// ͂̂܂
		iBmpHeight	= ( iScreenHeight*iPictureWidth ) / iScreenWidth;	// ScrHeight * ( PicWidth / ScrWidth )
	} else {								// 摜XN[̕ɒꍇ
		iBmpHeight	= iPictureHeight;		// ͂̂܂
		iBmpWidth	= ( iScreenWidth*iPictureHeight ) / iScreenHeight;	// ScrWidth * ( PicHeight / ScrHeight )
	}

	// 摜̃ItZbgvZ
	UINT uOffsetX;
	UINT uOffsetY;
	uOffsetX	= ( iBmpWidth  - iPictureWidth  ) / 2;
	uOffsetY	= ( iBmpHeight - iPictureHeight ) / 2;


	// FvZ
	int	iColorDepth;								// J[fvX
	iColorDepth	= GetColorDepth();


	// C[W̑傫vZ
	UINT uRasterSize , uImageSize , uRasterHeight;
	uRasterHeight= iBmpHeight;
	uRasterSize	 = ( iBmpWidth * GetColorDepth() )/8;	// oCg
	uRasterSize += ( 4-(uRasterSize&3) )&3;				// SoCgE
	uImageSize	 = uRasterSize * iBmpHeight;			// đŜ̃TCY

	UINT uPictureRasterSize;
	uPictureRasterSize  = ( iPictureWidth * GetColorDepth() )/8;	// oCg
	uPictureRasterSize += ( 4-(uPictureRasterSize&3) )&3;			// SoCgE

	// C[Ŵ߂̃m
	BYTE*	pImage;
	pImage	= (BYTE*)malloc( uImageSize );
	if( pImage==NULL ){								// ̊mۂɎs
		return FALSE;
	}

	int iRQNum;										// RGBQUAD ̐
	if( GetColorDepth()<=8 )iRQNum	= 1<<GetColorDepth();
	else	iRQNum	= 0;


	// wb_
	BITMAPFILEHEADER	bmfh;
	BITMAPINFOHEADER	bmih;

	// BMPFILEHEADER ̍\z
	bmfh.bfType			= 0x4D42;
	bmfh.bfSize			= sizeof( BITMAPFILEHEADER )
						+ sizeof( BITMAPINFOHEADER )
						+ ( sizeof( RGBQUAD ) * iRQNum )
						+ uImageSize;
	bmfh.bfReserved1	= 0;
	bmfh.bfReserved2	= 0;
	bmfh.bfOffBits		= sizeof( BITMAPFILEHEADER )
						+ sizeof( BITMAPINFOHEADER )
						+ ( sizeof( RGBQUAD ) * iRQNum );

	// BMPINFOHEADER ̍\z
	bmih.biSize			= sizeof( BITMAPINFOHEADER );
	bmih.biWidth		= iBmpWidth;
	bmih.biHeight		= iBmpHeight;
	bmih.biPlanes		= GetBMIH()->biPlanes;
	bmih.biBitCount		= GetBMIH()->biBitCount;
	bmih.biCompression	= GetBMIH()->biCompression;
	bmih.biSizeImage	= uImageSize;
	bmih.biXPelsPerMeter= GetBMIH()->biXPelsPerMeter;
	bmih.biYPelsPerMeter= GetBMIH()->biYPelsPerMeter;
	bmih.biClrUsed		= GetBMIH()->biClrUsed;
	bmih.biClrImportant	= GetBMIH()->biClrImportant;

	// 摜̍č\z
	UINT x,y;
	BYTE* pSrc , *pDest;
	pSrc	= (BYTE*)m_lpBits;							// ǂݍ݂
	pDest	= pImage;									// ʐ

	for( y=0;y<uOffsetY;y++ ){							// ̃ItZbg
		for( x=0;x<uRasterSize;x++ ){
			*pDest++ = 0;
		}
	}

	for( y=0;y<(UINT)iPictureHeight;y++ ){				// 摜
		for( x=0;x<(uOffsetX*GetColorDepth())/8;x++ ){									// ̃ItZbg
			*pDest++ = 0;
		}
		for( x=0;x<uPictureRasterSize;x++ ){											// 摜
			*pDest++ = *pSrc++;
		}
		for( x=0;x<uRasterSize-uPictureRasterSize-((uOffsetX*GetColorDepth())/8);x++ ){	// ẼItZbg
			*pDest++ = 0;
		}
	}

	for( y=0;y<uRasterHeight-iPictureHeight-uOffsetY;y++ ){	// ̃ItZbg
		for( x=0;x<uRasterSize;x++ ){
			*pDest++ = 0;
		}
	}

	// 摜̃Z[u
	FILE*	pStream;
	pStream	= fopen( pFName , "wb" );
	if( pStream==NULL ){
		free( pImage );
		return FALSE;
	}

	fwrite( &bmfh , sizeof( BITMAPFILEHEADER ) , 1 , pStream );
	fwrite( &bmih , sizeof( BITMAPINFOHEADER ) , 1 , pStream );
	if( GetColorDepth()<24 ){								// CfbNXJ[̏ꍇ
		// RGBQUADo
		RGBQUAD	quad;
		UINT	uColors;
		uColors = (1<<GetColorDepth());						// FvZ
		for( UINT i=0;i<uColors;i++ ){
			quad = GetPalet( i );							// pbg擾
			fwrite( &quad,sizeof( RGBQUAD ),1,pStream );	// 
		}
	}
	fwrite( pImage               , uImageSize                 , 1 , pStream );
	fclose( pStream );

	free( pImage );

	// I
	return TRUE;											// I
}


//------------------------------------------------<< 摜j >>
void CBmp::Free()
{
	if( m_isSet==FALSE )return;				// f[^ǂ܂ĂȂ΃LZ

	// alonh̉
	if( m_isBitOperating==FALSE ){			// rbgڑ쒆łȂ
		DeleteObject( m_hBmp );				// alo
	}

	// pbgnh̉
	if( !m_isFullColor ){					// pbg
		if( m_isBitOperating==FALSE )DeleteObject( m_hPal );
		GlobalFree( (HGLOBAL)m_lpLogPal );
	}

	// 
	GlobalFree( m_lpBits );
	GlobalFree( (HGLOBAL)m_lpbmi );
	m_isSet	= FALSE;
}


//------------------------------------------------<< wcb̎wʒuɎw͈͂ŕ` >>
void CBmp::FrameDraw( CPoint& src,CRect& dist,CDC *pDC )
{
	if( m_isSet==FALSE )return;					// f[^͏ĂȂB

	CDC memDC;									// cb
	memDC.CreateCompatibleDC( pDC );			// Rp`uݒ

	CBitmap *tempbmp;
	tempbmp	= CBitmap::FromHandle( m_hBmp );	// ꎞICBitmapObject쐬
	memDC.SelectObject( tempbmp );				// cbɑI

	if( !m_isFullColor ){						// tJ[łȂ΃pbgrealize
		pDC->SelectPalette( CPalette::FromHandle( m_hPal ),FALSE);
		pDC->RealizePalette();
	}

	pDC->BitBlt( dist.left,dist.top				// `I
		,abs(dist.right-dist.left)+1,abs(dist.bottom-dist.top)+1
		,&memDC,src.x,src.y,SRCCOPY);
}


//---------------------------------------------------<< Pɕ` >>
void CBmp::NormalDraw(CPoint& dist,CDC *pDC)
{
	if(m_isSet==FALSE)return;						// f[^͏ĂȂB

	CDC memDC;									// cb
	memDC.CreateCompatibleDC(pDC);				// Rp`uݒ

	CBitmap *tempbmp;
	tempbmp=CBitmap::FromHandle(m_hBmp);			// ꎞICBitmapObject쐬
	memDC.SelectObject(tempbmp);				// cbɑI

	if(!m_isFullColor){							// tJ[łȂ΃pbgrealize
		pDC->SelectPalette( CPalette::FromHandle( m_hPal ),FALSE );
		pDC->RealizePalette();
	}

	pDC->BitBlt( dist.x,dist.y,m_bmih.biWidth,m_bmih.biHeight	// `I
		,&memDC,0,0,SRCCOPY);
}



//--------------------------<< wcb̎wʒuɎw蕔wTCYɃTCYĕ` >>
void CBmp::StretchDraw(CRect& src,CRect& dist,CDC *pDC)
{
	if(m_isSet==FALSE)return;						// f[^͏ĂȂB

	CDC memDC;									// cb
	memDC.CreateCompatibleDC(pDC);				// Rp`uݒ

	CBitmap *tempbmp;
	tempbmp=CBitmap::FromHandle(m_hBmp);			// ꎞICBitmapObject쐬
	memDC.SelectObject(tempbmp);				// cbɑI

	if(!m_isFullColor){							// tJ[łȂ΃pbgrealize
		pDC->SelectPalette(CPalette::FromHandle(m_hPal),FALSE);
		pDC->RealizePalette();
	}

	int oldSBM;
	oldSBM = pDC->SetStretchBltMode( COLORONCOLOR );
	pDC->StretchBlt(dist.left,dist.top			// `I
		,abs(dist.right-dist.left),abs(dist.bottom-dist.top)
		,&memDC
		,src.left,src.top
		,abs(src.right-src.left),abs(src.bottom-src.top)
		,SRCCOPY);
	pDC->SetStretchBltMode( oldSBM );
}


//-----------------------------------------------------------------<< 摜̕Ԃ >>
int CBmp::GetWidth()
{
	if(m_isSet==FALSE)return 0;			// 摜ǂ܂ĂȂ΂O
	return m_bmih.biWidth;				// 摜̕
}


//-----------------------------------------------------------------<< 摜̍Ԃ >>
int CBmp::GetHeight()
{
	if(m_isSet==FALSE)return 0;			// 摜ǂ܂ĂȂ΂O
	return m_bmih.biHeight;				// 摜̍
}


//-----------------------------------------------------------------<< J[fvXԂ >>
int CBmp::GetColorDepth()
{
	if(m_isSet==FALSE)return 0;			// 摜ǂ܂ĂȂ΂O
	return m_bmih.biBitCount;				// 摜̃rbgfvX
}

//-----------------------------------------------------------------<< FԂ >>
int CBmp::GetColorNum()
{
	if(m_isSet==FALSE)return 0;			// 摜ǂ܂ĂȂ΂O
	return 1<<m_bmih.biBitCount;		// 摜̐F
}


//-----------------------------------------------------------------<< 摜̃TCYԂ >>
CSize CBmp::GetSize()
{
	if(m_isSet==FALSE)return CSize(0,0);	// 摜ǂ܂ĂȂ΂O
	CSize result;
	result.cx=m_bmih.biWidth;			// Zbg
	result.cy=m_bmih.biHeight;		// Zbg
	return result;					// TCYԂ
}


//-------------------------------------------------------------<< alonhԂ >>
HBITMAP CBmp::GetBmpHandle()
{
	if(m_isSet == FALSE)return(0);
	if(m_isBitOperating)return(0);			// rbg쒆ȂOԂ
	else return(m_hBmp);
}


//-------------------------------------------------------------<< BITMAPFILEHEADERւ̃|C^Ԃ >>
BITMAPFILEHEADER* CBmp::GetBMFH()
{
	return &m_bmfh;
}


//-------------------------------------------------------------<< BITMAPINFOHEADERւ̃|C^Ԃ >>
BITMAPINFOHEADER* CBmp::GetBMIH()
{
	return &m_bmih;
}


//-------------------------------------------------<< alo\̏łĂ邩ۂ >>
BOOL CBmp::isReady()
{
	return m_isSet;
}


//----------------------------------------------------------<< w index ̃pbgԂ >>
RGBQUAD CBmp::GetPalet( int index )
{
	RGBQUAD quad;
	memset( &quad , 0 , sizeof(RGBQUAD) );
	if( isReady()==FALSE )return quad;						// łĂȂȂ0Ԃ

	int colors = 1<<m_bmih.biBitCount;					// FvZ
	if( m_bmih.biBitCount>=24 )return quad;				// tJ[Ȃ0Ԃ
	if( index >= colors )return quad;					// index ԈĂȂ0Ԃ

	return m_lpbmi->bmiColors[index];
}


//--------------------------------------------<< wʒũsNZ̃pbgR[hԂ >>
RGBQUAD CBmp::GetPixelColor( int x, int y )
{
	int cy;
	cy = m_bmih.biHeight-y-1;				// {gAbv̊Z

	RGBQUAD quad;
	memset( &quad , 0 , sizeof(RGBQUAD) );
	if( isReady()==FALSE )return quad;					//łĂȂȂ0Ԃ
	if( x >= m_bmih.biWidth )return quad;					// NbsO
	if( y >= m_bmih.biHeight)return quad;
	if( x<0 )return quad;
	if( y<0 )return quad;

	int colors=1<<m_bmih.biBitCount;						// FvZ


	if( m_bmih.biBitCount>=24 ){							// tJ[̏ꍇ
		int offset;									// ItZbgvZ
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);

		BYTE *work;									// FZo
		work = ((BYTE*)m_lpBits)+offset;
		quad.rgbRed   = *(work+2);
		quad.rgbGreen = *(work+1);
		quad.rgbBlue  = *(work+0);
		return quad;
	}
														// QTUF̏ꍇ
	if( m_bmih.biBitCount==8 ){
		int offset;									// ItZbgvZ
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);

		BYTE *work;									// FZo
		work = ((BYTE*)m_lpBits)+offset;
		return GetPalet( *work );
	}

	if( m_bmih.biBitCount==4 ){							// PUF̏ꍇ
		int offset,uplow;								// ItZbgAupper  lower
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);
		uplow  = ( (m_bmih.biWidth*cy)+x )&1;

		BYTE *work;									// FZo
		work = ((BYTE*)m_lpBits)+offset;
		if( uplow )return GetPalet( (*work)&15 );
		else return	GetPalet( (*work)/16 );
	}

	return quad;										// T|[gĂȂrbg}bv0Ԃ
}


//--------------------------------------------<< wʒũsNZ̃CfbNXԂ >>
//  tJ[ꍇ -1(Error) Ԃ
int CBmp::GetPixelIndex( int x, int y )
{
	if( isReady()==FALSE )return -1;					//łĂȂȂ0Ԃ
	if( x >= m_bmih.biWidth )return -1;					// NbsO
	if( y >= m_bmih.biHeight)return -1;
	if( x<0 )return -1;
	if( y<0 )return -1;
	if( m_bmih.biBitCount==24 )return -1;					// tJ[ȂG[

	int cy;
	cy = m_bmih.biHeight-y-1;				// {gAbv̊Z

	if( m_bmih.biBitCount==8 ){						// QTUF̏ꍇ
		int offset;									// ItZbgvZ
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);

		BYTE *work;									// |CgZo
		work = ((BYTE*)m_lpBits)+offset;
		return *work;
	}

	if( m_bmih.biBitCount==4 ){							// PUF̏ꍇ
		int offset,uplow;								// ItZbgAupper  lower
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);
		uplow  = ( (m_bmih.biWidth*cy)+x )&1;

		BYTE *work;									// |CgZo
		work = ((BYTE*)m_lpBits)+offset;
		if( uplow )return (*work)&15;
		else return	((*work)/16)&15;
	}

	return -1;										// T|[gĂȂrbg}bv-1Ԃ
}



//-------------------------------------------<< rbgz̒ڑ̏ >>
void CBmp::PrepareBitOperation()
{
	if( isReady()==FALSE )return;						// 摜łĂȂΕԂ
	if( m_isBitOperating )return;						// łɏłĂȂ牽Ȃ

	DeleteObject( m_hBmp );								// alonĥłB
	if( !m_isFullColor )DeleteObject( m_hPal );			// pbgnh
	m_isBitOperating=TRUE;								// rbgz̒ڑ̏
}


//-------------------------------------------<< rbgz̒ڑI >>
void CBmp::EndBitOperation(CDC* pDC)
{
	if( isReady()==FALSE )return;							// 摜łĂȂȂԂ
	if( m_isBitOperating==FALSE )return;					// rbg̒ڑ쒆łȂΕԂ

	// nh쐬
	m_hBmp = CreateDIBitmap( pDC->m_hDC,&m_bmih,CBM_INIT,m_lpBits,m_lpbmi,DIB_RGB_COLORS );

	if( !m_isFullColor )m_hPal=CreatePalette( m_lpLogPal );	// pbgnh쐬
	m_isBitOperating=FALSE;									// rbg̒ڑ쒆ł͂ȂƂ
}


//----------------------------------------------------------<< w index Ƀpbgݒ肷 >>
void CBmp::SetPalet( int index , RGBQUAD& quad )
{
	if( isReady()==FALSE )return;						// łĂȂȂ0Ԃ
	if( m_isBitOperating==FALSE )return;					// rbg̏łĂȂȂԂ
	if( m_bmih.biBitCount>=24 )return;

	int colors = 1<<m_bmih.biBitCount;					// FvZ
	if( index >= colors )return;						// index ԈĂȂ0Ԃ

	m_lpbmi->bmiColors[index] = quad;						// Fݒ

	m_lpLogPal->palPalEntry[index].peRed  =quad.rgbRed;	// log palette ɂݒ
	m_lpLogPal->palPalEntry[index].peGreen=quad.rgbGreen;
	m_lpLogPal->palPalEntry[index].peBlue =quad.rgbBlue;

	return;
}


//-------------------------------------------<< wʒuɃsNZuitJ[̎̂݁j >>
BOOL CBmp::SetPixelColor( int x, int y , RGBQUAD& quad )
{
	if( isReady()==FALSE )return FALSE;						// łĂȂΕԂ
	if( m_isBitOperating==FALSE )return FALSE;			// rbg̏łĂȂȂԂ
	if( m_bmih.biBitCount!=24 )return FALSE;				// tJ[ȂΕԂ

	int cy;
	cy = m_bmih.biHeight-y-1;				// {gAbv̊Z

	if( isReady()==FALSE )return FALSE;					//łĂȂȂFALSEԂ
	if( x >= m_bmih.biWidth )return FALSE;					// NbsO
	if( y >= m_bmih.biHeight)return FALSE;
	if( x<0 )return FALSE;
	if( y<0 )return FALSE;

	int offset;									// ItZbgvZ
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);

	BYTE *work;									// Fzu
	work = ((BYTE*)m_lpBits)+offset;
	*(work+2) = quad.rgbRed;
	*(work+1) = quad.rgbGreen;
	*(work+0) = quad.rgbBlue;

	return TRUE;										// I
}


//-------------------------------------------<< wʒuɃsNZuiCfbNX̂݁j >>
BOOL CBmp::SetPixelIndex( int x, int y , int col )
{
	if( isReady()==FALSE )return FALSE;					// łĂȂΕԂ
	if( m_isBitOperating==FALSE )return FALSE;			// rbgz̒ڑ̏łĂȂΕԂ
	if( m_bmih.biBitCount==24 )return FALSE;			// tJ[̓_
	if( m_bmih.biBitCount<  4 )return FALSE;			// PUF菭Ȃ̂_iQFƂj

	int cy;
	cy = m_bmih.biHeight-y-1;							// {gAbv̊Z

	if( x >= m_bmih.biWidth )return FALSE;				// NbsO
	if( y >= m_bmih.biHeight)return FALSE;
	if( x<0 )return FALSE;
	if( y<0 )return FALSE;

										// QTUF̏ꍇ
	if( m_bmih.biBitCount==8 ){
		int offset;									// ItZbgvZ
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);

		BYTE *work;									// |C^̈ʒuZo
		work = ((BYTE*)m_lpBits)+offset;
		*work = col;								// Fzu

		return TRUE;
	}

	if( m_bmih.biBitCount==4 ){							// PUF̏ꍇ
		int offset,uplow;								// ItZbgAupper  lower
		offset = (GetWidthByte()*cy) + ((x*m_bmih.biBitCount)/8);
		uplow  = ( (m_bmih.biWidth*cy)+x )&1;

		BYTE *work;									// FZo
		work = ((BYTE*)m_lpBits)+offset;
		BYTE temp;
		temp = *work;
		if( uplow ){								// ̂Srbg
			temp &= 0xF0;
			temp |= col&0x0F;
			*work = temp;
			return TRUE;
		} else {									// ̂Srbg
			temp &= 0x0F;
			temp |= (col<<4)&0xF0;
			*work = temp;
			return TRUE;
		}
	}

	return FALSE;										// ܂ŗ锤͂ȂB
														// bmih.biBitCount̒lɌ肪\
}


//-------------------------------------------<< wʒuɃsNZuiCfbNX̂݁j >>
UINT CBmp::GetWidthByte()
{
	UINT res;
	res = (m_bmih.biWidth*m_bmih.biBitCount)/8;							// oCg
	res += ( 4-(res&3) )&3;											// SoCgE
	return res;														// ʂԂ
}
