//------------------------------------------------------------------------------
//	NX
//------------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>

#include "Str.h"


//--------------------------------------------------------------------
//	[  ]
//		CGStr()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		Ȃ
//
//	[  ]
//		RXgN^
//--------------------------------------------------------------------
CGStr::CGStr()
{
	// <<< lݒ >>>
	SetDefault();
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr( CGStr& rStr )
//
//	[  ]
//		CGStr& rStr					Rs[ƃIuWFNgւ̎Q
//
//	[ ߂l ]
//		Ȃ
//
//	[  ]
//		Rs[RXgN^
//--------------------------------------------------------------------
CGStr::CGStr( CGStr& rStr )
{
	// <<< lݒ >>>
	SetDefault();

	// <<< IuWFNg̓e𕡐 >>>
	BOOL bRes;
	bRes	= CopyMembers( rStr );
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr( const char* pStr )
//
//	[  ]
//		const char* pStr			ݒ肷镶
//
//	[ ߂l ]
//		Ȃ
//
//	[  ]
//		񏉊̃RXgN^
//--------------------------------------------------------------------
CGStr::CGStr( const char* pStr )
{
	// <<< lݒ >>>
	SetDefault();

	// <<< IuWFNgɕݒ >>>
	BOOL bRes;
	bRes = SetString( pStr );
}


//--------------------------------------------------------------------
//	[  ]
//		~CGStr()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		Ȃ
//
//	[  ]
//		fXgN^
//--------------------------------------------------------------------
CGStr::~CGStr()
{
	// -----<  >-----
	//
	BOOL bRes;
	bRes = Release();
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL SetDefault()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		RXgN^xł̏lݒ
//--------------------------------------------------------------------
BOOL CGStr::SetDefault()
{
	m_pString	= NULL;
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL CopyMembers( const CGStr& rStr )
//
//	[  ]
//		const CGStr& rStr			Rs[ƃIuWFNgւ̎Q
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		IuWFNg̓e𕡐܂B
//--------------------------------------------------------------------
BOOL CGStr::CopyMembers( const CGStr& rStr )
{
	// <<<  >>>
	BOOL bRes;
	bRes = Initialize();
	if( bRes==FALSE ){
		return FALSE;
	}

	// <<< ݒ >>>
	//
	bRes = SetString( rStr.GetString() );
	if( bRes==FALSE ){
		return FALSE;
	}

	// <<< I >>>
	//
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL FreeString()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		ݒ肳Ă镶܂B
//--------------------------------------------------------------------
BOOL CGStr::FreeString()
{
	if( m_pString!=NULL ){
		free( m_pString );
	}
	m_pString	= NULL;
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Initialize()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		
//--------------------------------------------------------------------
BOOL CGStr::Initialize()
{
	// <<<  >>>
	BOOL bRes;
	bRes = Release();
	if( bRes==FALSE ){
		return FALSE;
	}

	// Ƃ邱Ɩ
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Release()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		IuWFNg̓ejAmۂĂ郊\[X܂B
//--------------------------------------------------------------------
BOOL CGStr::Release()
{
	// <<< ̉ >>>
	BOOL bRes = FreeString();
	if( bRes==FALSE ){
		return FALSE;
	}

	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL SetString( const char* pString )
//
//	[  ]
//		const char* pString			ݒ肷镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		IuWFNgɑ΂ĕݒ肵܂B
//		̕񂪂ꍇɂ́AxĂ
//		Vݒ肵܂B
//		pString  NULL w肵ꍇ́Aݒ肳Ă镶
//		Ċ֐I܂B
//--------------------------------------------------------------------
BOOL CGStr::SetString( const char* pString )
{
	// <<< NULL ̏ꍇ͕ďI >>>
	if( pString==NULL ){
		FreeString();
		return TRUE;
	}

	// <<< ̒𑪂 >>>
	long lLength;
	lLength	= strlen( pString );

	// <<< mۂ >>>
	char* pNewString;
	pNewString	= (char*)malloc( lLength+1 );
	if( pNewString==NULL ){
		return FALSE;
	}
	memset( pNewString , 0 , lLength+1 );

	// <<< 񕡐 >>>
	strcpy( pNewString , pString );

	// <<< ̕񂪂ꍇɂ͉ >>>
	if( m_pString!=NULL ){
		free( m_pString );
	}
	m_pString = NULL;

	// <<< VKݒ >>>
	m_pString = pNewString;

	// <<< I >>>
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		const char* GetString() const
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		IuWFNgɊi[Ă镶
//
//	[  ]
//		 char* ŕԂ܂B
//--------------------------------------------------------------------
const char* CGStr::GetString() const
{
	return m_pString;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL AppendString( const char* pString )
//
//	[  ]
//		const char* pString			ǉ镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̂ɕڑ܂B
//--------------------------------------------------------------------
BOOL CGStr::AppendString( const char* pString )
{
	BOOL bRes;

	// <<< NULL wȂȂɂȂ >>>
	if( pString==NULL ){
		return TRUE;
	}

	// <<< 𑪂ăm >>>
	long lLength;
	lLength	= strlen( pString ) + Length();

	char* pNewString;
	pNewString	= (char*)malloc( lLength+1 );
	if( pNewString==NULL ){
		return FALSE;
	}
	memset( pNewString , 0 , lLength+1 );

	// <<< 񕡐 >>>
	if( GetString()!=NULL ){
		strcpy( pNewString , GetString() );
	}
	strcat( pNewString , pString );

	// <<< ̕ĐVݒ >>>
	bRes = SetString( pNewString );
	if( bRes==FALSE ){
		free( pNewString );
		return FALSE;
	}

	free( pNewString );
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL AppendString( const CGStr& rString )
//
//	[  ]
//		CGStr& rString				ǉ镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̌ɕA܂B
//--------------------------------------------------------------------
BOOL CGStr::AppendString( const CGStr& rString )
{
	BOOL bRes;
	bRes	= AppendString( rString.GetString() );
	return bRes;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL InsertString( const char* pString )
//
//	[  ]
//		char* pString				}镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̑Oɕڑ܂B
//--------------------------------------------------------------------
BOOL CGStr::InsertString( const char* pString )
{
	BOOL bRes;

	// <<< NULL wȂȂɂȂ >>>
	if( pString==NULL ){
		return TRUE;
	}

	// <<< 𑪂ăm >>>
	long lLength;
	lLength	= strlen( pString ) + Length();

	char* pNewString;
	pNewString	= (char*)malloc( lLength+1 );
	if( pNewString==NULL ){
		return FALSE;
	}
	memset( pNewString , 0 , lLength+1 );

	// <<< ̕ >>>
	strcpy( pNewString , pString );
	if( m_pString!=NULL ){
		strcat( pNewString , GetString() );
	}

	// <<< ̕ŐVKݒ >>>
	bRes = SetString( pNewString );
	if( bRes==FALSE ){
		free( pNewString );
		return FALSE;
	}

	free( pNewString );

	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL InsertString( const CGStr& rString )
//
//	[  ]
//		CGStr& rString				A镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̑Oɕ}ĘA܂B
//--------------------------------------------------------------------
BOOL CGStr::InsertString( const CGStr& rString )
{
	BOOL bRes;
	bRes	= InsertString( rString.GetString() );
	return bRes;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL DeleteLastCR()
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̈ԍŌオ \n A \0 ɒu܂B
//--------------------------------------------------------------------
BOOL CGStr::DeleteLastCR()
{
	BOOL bRes;

	// <<< 񂪂Ȃ΁Â܂܂܂ >>>
	if( m_pString==NULL ){
		return TRUE;
	}

	// <<< ŌT >>>
	unsigned char* pWork;
	unsigned char* pLast;

	pWork	= (unsigned char*)m_pString;
	pLast	= pWork;

	while( 1 ){
		if( IsEndCode( pWork )==TRUE ){
			break;
		}
		pLast	= pWork;					// GhR[hł͂Ȃ̂ōXV

		pWork += GetMBLetterSize( (char*)pWork );	// ̕mF
	}

	// <<< Ōオ \n GhR[hɂ >>>
	if( IsCRCode( pLast )==TRUE ){
		bRes = SetEndCode( pLast );
		if( bRes==FALSE ){
			return FALSE;
		}
	}

	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL StrLast( const CGStr& rString ) const
//
//	[  ]
//		const CGStr& rString		܂܂邩ۂmF镶
//
//	[ ߂l ]
//		  ܂܂FTRUE
//		܂܂ȂFFALSE
//
//	[  ]
//		񂪁ArString ŎŏIĂꍇ TRUE 
//		Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::StrLast( const CGStr& rString ) const
{
	BOOL bRes;
	bRes	= StrLast( rString.GetString() );
	return bRes;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL StrLast( const char* pString ) const
//
//	[  ]
//		const char* pString			܂܂邩ۂmF镶
//
//	[ ߂l ]
//		  ܂܂FTRUE
//		܂܂ȂFFALSE
//
//	[  ]
//		񂪁ApString ŎŏIĂꍇ TRUE 
//		Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::StrLast( const char* pString ) const
{
	long	lLength;
	long	lStringLength;
	CGStr	objString;

	// 񒷂mF
	objString	= pString;
	lLength			= Length();
	lStringLength	= objString.Length();

	// rʒumF
	long lDiff;
	lDiff	= lLength - lStringLength;
	if( lDiff<0 ){
		return FALSE;
	}

	// r
	BOOL bResult;
	if( strcmp( m_pString+lDiff , pString )==0 ){
		bResult	= TRUE;
	} else {
		bResult	= FALSE;
	}

	return bResult;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL DeleteLastStr( const CGStr& rString )
//
//	[  ]
//		const CGStr& rString			폜镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̍Ō rString ĂꍇA폜܂B
//		iGhR[h㏑܂Bj
//		̍Ō rString ĂȂꍇɂ́A
//		Ȃɂ TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::DeleteLastStr( const CGStr& rString )
{
	BOOL        bRes;
	const char* pString = rString.GetString();

	bRes	= DeleteLastStr( pString );
	return bRes;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL DeleteLastStr( const char* pString )
//
//	[  ]
//		const char* pString			폜镶
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		̍Ō pString ĂꍇA폜܂B
//		iGhR[h㏑܂Bj
//		̍Ō pString ĂȂꍇɂ́A
//		Ȃɂ TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::DeleteLastStr( const char* pString )
{
	long	lLength;					// 
	long	lStringLength;				// w肳ꂽ̒
	CGStr	objString;					// w肳ꂽ CGStr ɂ
	BOOL	bRes;

	// 񒷂mF
	objString		= pString;
	lLength			= Length();
	lStringLength	= objString.Length();

	// rʒumF
	long lDiff;
	lDiff	= lLength - lStringLength;
	if( lDiff<0 ){
		return TRUE;
	}

	// r
	if( strcmp( m_pString+lDiff , pString )!=0 ){
		// ŌɊ܂܂Ȃ̂ŁAɕԂ
		return TRUE;
	}

	// GhR[hŏ㏑
	bRes	= SetEndCode( (unsigned char*)(m_pString+lDiff) );
	if( bRes==FALSE ){
		return FALSE;
	}

	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL IsHead( const char* pString )
//		BOOL IsHead( const CGStr& rString )
//
//	[  ]
//		const char* pString			r
//		const CGStr& rString		r
//
//	[ ߂l ]
//		v@@@FTRUE
//		vȂFFALSE
//
//	[  ]
//		̐擪Aw肵ƈv邩ۂ𔻒肵܂B
//		Ƃ΁A"0x00FF00FF" ɑ΂ "0x" Ɏw肵s
//		TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::IsHead( const char* pString )
{
	int iRes;

	// 擪r
	iRes	= _mbsncmp( (const unsigned char*)m_pString , (const unsigned char*)pString , _mbstrlen( pString ) );

	// ʂԂ
	if( iRes!=0 )return FALSE;
	return TRUE;
}

BOOL CGStr::IsHead( const CGStr& rString )
{
	BOOL bRes;
	bRes	= IsHead( rString.GetString() );
	return bRes;
}


//--------------------------------------------------------------------
//	[  ]
//		long Length() const
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		ݒ肳Ă镶̒
//		G[̏ꍇ -1
//
//	[  ]
//		ݒ肳Ă镶̒oCgPʂŕԂ܂B
//		񂪐ݒ肳ĂȂꍇ 0 Ԃ܂B
//--------------------------------------------------------------------
long CGStr::Length() const
{
	// <<< ݒ肳ĂȂ 0 Ԃ >>>
	if( m_pString==NULL ){
		return 0;
	}

	// <<< 𐔂ĕԂ >>>
	long lLength;
	lLength	= strlen( m_pString );

	return lLength;
}


//--------------------------------------------------------------------
//	[  ]
//		long MBLength() const
//
//	[  ]
//		Ȃ
//
//	[ ߂l ]
//		ݒ肳Ă镶
//
//	[  ]
//		ݒ肳Ă镶̕Ԃ܂B
//		}`oCgɂĂAPPJEg܂B
//--------------------------------------------------------------------
long CGStr::MBLength() const
{
	// <<< ݒ肳ĂȂ 0 >>>
	if( m_pString==NULL ){
		return 0;
	}

	// << |C^ & o >>>
	long	lLength;
	char*	pWork;

	lLength	= 0;
	pWork	= m_pString;
	while( 1 ){
		// GhR[hŔ
		if( *pWork==0 ){
			break;
		}

		// JEg
		lLength += 1;
		pWork	+= GetMBLetterSize( pWork );
	}

	// <<< Ԃ >>>
	return lLength;
}


//--------------------------------------------------------------------
//	[  ]
//		long GetMBLetterSize( const char* pLetter )
//
//	[  ]
//		ւ̃|C^
//
//	[ ߂l ]
//		pLetter ẃA擪̃oCg
//
//	[  ]
//		̃oCgԂ܂B
//		̊֐́AS-JIS pɋLqĂ܂B
//--------------------------------------------------------------------
long CGStr::GetMBLetterSize( const char* pLetter )
{
	unsigned char cLetter;
	cLetter	= (unsigned char)(*pLetter);

	// WrbgڂɃrbgĂȂΔp
	if( cLetter<0x80 ){
		return 1;
	}

	// J^Jȉꍇ͔p
	if( (cLetter>=0xA0) && (cLetter<=0xDF) ){
		return 1;
	}

	// WrbgڂĂăJ^Jił͂Ȃ̂łQoCgR[h
	return 2;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL IsEndCode( const unsigned char* pLetter )
//
//	[  ]
//		const unsigned char* pLetter	ւ̃|C^
//
//	[ ߂l ]
//		        GhR[hFTRUE
//		GhR[hł͂ȂFFALSE
//
//	[  ]
//		ւ̐擪 pLetter Ɏw肵܂B
//		pLetter GhR[hwĂꍇɂ TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::IsEndCode( const unsigned char* pLetter )
{
	if( *pLetter==0x00 ){
		return TRUE;
	}

	return FALSE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL IsCRCode( const unsigned char* pLetter )
//
//	[  ]
//		const unsigned char* pLetter	ւ̃|C^
//
//	[ ߂l ]
//		  sR[hFTRUE
//		sł͂ȂFFALSE
//
//	[  ]
//		ւ̐擪 pLetter Ɏw肵܂B
//		pLetter sR[hwĂꍇɂ TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::IsCRCode( const unsigned char* pLetter )
{
	if( *pLetter=='\n' ){
		return TRUE;
	}

	return FALSE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL SetEndCode( unsigned char* pLetter )
//
//	[  ]
//		char* pLetter				GhR[h
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		pLetter ɃGhR[h݂܂B
//--------------------------------------------------------------------
BOOL CGStr::SetEndCode( unsigned char* pLetter )
{
	*pLetter	= 0x00;
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Explode( const CGStr& rKey , CDStringArray& rElements )
//
//	[  ]
//		const CGStr&   rKey			̃L[ƂȂ镶
//		CDStringArray& rElements	ʂi[邽߂ CDStringArray ւ̎Q
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		 rKey ŕAz rElements Ɋi[܂B
//--------------------------------------------------------------------
BOOL CGStr::Explode( const CGStr& rKey , CDStringArray& rElements )
{
	BOOL bRes;

	// <<< 𕡐 >>>
	unsigned char* pString;
	pString	= (unsigned char*)malloc( Length()+CGSTR_MAX_ENDCODE );
	if( pString==NULL ){
		return NULL;
	}
	memcpy( pString , GetString() , Length() );
	bRes = SetEndCode( pString+Length() );
	if( bRes==FALSE ){
		free( pString );
		return FALSE;
	}

	// <<< Ȃi[ >>>
	unsigned char*	pTop;
	unsigned char*	pWork;

	rElements.Release();
	pTop	= pString;
	pWork	= pString;

	while( 1 ){
		// ؂蕶A̓GhR[hƈvA؂菈
		if(    (CheckKey( pWork , rKey )==TRUE)
			|| (IsEndCode( pWork )      ==TRUE)
		){
			// vf擾
			long lLength;
			lLength = pWork-pTop;

			// vfpm
			unsigned char* pElem;
			pElem = (unsigned char*)malloc( lLength+CGSTR_MAX_ENDCODE );
			if( pElem==NULL ){
				free( pString );
				return FALSE;
			}
			memcpy( pElem,pTop,lLength );
			bRes = SetEndCode( pElem+lLength );
			if( bRes==FALSE ){
				free( pElem );
				free( pString );
				return FALSE;
			}

			// vfǉ
			long lIndex;
			lIndex = rElements.Add( (char*)pElem );
			free( pElem );
			if( lIndex==-1 ){
				free( pString );
				return FALSE;
			}

			// GhR[hȂI
			if( IsEndCode( pWork )==TRUE ){
				break;
			}

			// GhR[hłȂ΃|C^𓮂
			pWork	= pWork + rKey.Length();
			pTop	= pWork;
			continue;
		}

		// |C^i߂
		long lLetterLength;
		lLetterLength	= GetMBLetterSize( (char*)pWork );
		pWork			+= lLetterLength;
	}

	// <<< ꎞobt@ďI >>>
	free( pString );
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Explode( const char* pKey , CDStringArray& rElements )
//
//	[  ]
//		const char*    pKey			̃L[ƂȂ镶
//		CDStringArray& rElements	ʂi[邽߂ CDStringArray ւ̎Q
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		 pKey ŕAz rElements Ɋi[܂B
//--------------------------------------------------------------------
BOOL CGStr::Explode( const char* pKey , CDStringArray& rElements )
{
	return Explode( CGStr( pKey ) , rElements );
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Implode( const CGStr& rKey , CDStringArray& rElements )
//
//	[  ]
//		CGStr&         rKey			vfԂɑ}镶
//		CDStringArray& rElements 	vfi[ CDStringArray ւ̎Q
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		z rElements Ɋi[ꂽArKey ŋ؂P
//		Ɍ܂B
//--------------------------------------------------------------------
BOOL CGStr::Implode( const CGStr& rKey , CDStringArray& rElements )
{
	long i;
	BOOL bRes;

	// <<< vf̐擾 >>>
	long lCount;
	lCount	= rElements.Length();

	// <<<  >>>
	CGStr	objResult;
	bRes = objResult.Initialize();
	if( bRes==FALSE ){
		return FALSE;
	}

	for( i=0;i<lCount;i++ ){
		if( i!=0 ){
			bRes = objResult.AppendString( rKey );
			if( bRes==FALSE ){
				return FALSE;
			}
		}

		bRes	= objResult.AppendString( rElements[ i ] );
		if( bRes==FALSE ){
			return FALSE;
		}
	}

	// <<< ʂi[ >>>
	bRes = SetString( objResult.GetString() );
	if( bRes==FALSE ){
		return FALSE;
	}

	// <<< I >>>
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Implode( const char* pKey , CDStringArray& rElements )
//
//	[  ]
//		const char*    pKey			vfԂɑ}镶
//		CDStringArray& rElements 	vfi[ CDStringArray ւ̎Q
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		z rElements Ɋi[ꂽApKey ŋ؂P
//		Ɍ܂B
//--------------------------------------------------------------------
BOOL CGStr::Implode( const char* pKey , CDStringArray& rElements )
{
	return Implode( CGStr( pKey ) , rElements );
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Split( const CGStr& rKey , CGStr& rLeft , CGStr& rRight )
//
//	[  ]
//		const CGStr& rKey			؂藣L[
//		CGStr&       rLeft			
//		CGStr&       rRight			E
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		Ɋ܂܂ rKey ̍ƉEŕ܂B
//		ʂ́ArLeft  rRight Ɋi[܂B
//		 rKey ܂܂Ȃꍇɂ FALSE ŕԂ܂B
//--------------------------------------------------------------------
BOOL CGStr::Split( const CGStr& rKey , CGStr& rLeft , CGStr& rRight )
{
	long i,c;
	BOOL bRes;

	// -----< 񒷎擾 >-----
	//
	long lLength;
	lLength	= Length();

	long lKeyLength;
	lKeyLength	= rKey.Length();

	// 񒷂̍擾
	long lDiff;
	lDiff	= lLength-lKeyLength;
	if( lDiff<0 ){
		return FALSE;
	}

	// -----< T >-----
	//
	long lIndex	= -1;
	for( i=0;i<lDiff;i++ ){
		BOOL bAgree = TRUE;
		for( c=0;c<lKeyLength;c++ ){
			if( m_pString[i+c]!=rKey.m_pString[c] ){
				bAgree = FALSE;
				break;
			}
		}

		if( bAgree==TRUE ){
			lIndex	= i;
			break;
		}

		// }`oCg̏ꍇ́ATCYԂ̕␳B
		long lLetterSize;
		lLetterSize = GetMBLetterSize( m_pString+(i+c) );
		i += lLetterSize -1;
	}

	// -----< L[ꍇ̓G[ >-----
	//
	if( lIndex==-1 ){
		return FALSE;
	}

	// -----< E쐬 >-----
	//
	// 
	unsigned char* pLeftString;
	pLeftString	= (unsigned char*)malloc( lIndex + CGSTR_MAX_ENDCODE );
	if( pLeftString==NULL ){
		return FALSE;
	}
	memcpy( pLeftString , m_pString , lIndex );
	bRes = SetEndCode( pLeftString + lIndex );
	if( bRes==FALSE ){
		free( pLeftString );
		return FALSE;
	}
	rLeft	= (char*)pLeftString;
	free( pLeftString );

	// E
	rRight	= m_pString + lIndex + lKeyLength;		// E쐬

	// -----< I >-----
	//
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL Split( const char* pKey , CGStr& rLeft , CGStr& rRight )
//
//	[  ]
//		const char* pKey			؂藣L[
//		CGStr&      rLeft			
//		CGStr&      rRight			E
//
//	[ ߂l ]
//		FTRUE
//		sFFALSE
//
//	[  ]
//		Ɋ܂܂ rKey ̍ƉEŕ܂B
//		ʂ́ArLeft  rRight Ɋi[܂B
//		 rKey ܂܂Ȃꍇɂ FALSE ŕԂ܂B
//--------------------------------------------------------------------
BOOL CGStr::Split( const char* pKey , CGStr& rLeft , CGStr& rRight )
{
	CGStr	objKey;
	objKey	= pKey;

	BOOL bRes;
	bRes	= Split( objKey , rLeft , rRight );
	if( bRes==FALSE ){
		return FALSE;
	}

	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL CheckKey( const unsigned char* pString , const CGStr& rKey )
//
//	[  ]
//		const unsigned char*  pString	̐擪ւ̃|C^
//		const CGStr& rKey				L[
//
//	[ ߂l ]
//		      vFTRUE
//		vȂFFALSE
//
//	[  ]
//		 pString ̐擪AL[ rKey ƈv邩
//		ۂmF܂B
//--------------------------------------------------------------------
BOOL CGStr::CheckKey( const unsigned char* pString , const CGStr& rKey )
{
	// L[ւ̃|C^擾
	const char* pKeyString = rKey.GetString();

	// L[񒷂擾
	long        lLength;
	lLength	= rKey.Length();

	// r
	long i;
	for( i=0;i<lLength;i++ ){
		if( pKeyString[i]!=pString[i] ){
			return FALSE;
		}
	}

	// v
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr& operator=( const CGStr& rStr )
//
//	[  ]
//		const CGStr& rStr			ƃIuWFNgւ̎Q
//
//	[ ߂l ]
//		ւ̎Q
//
//	[  ]
//		Zq
//--------------------------------------------------------------------
CGStr& CGStr::operator=( const CGStr& rStr )
{
	// <<< IuWFNg̓eRs[ >>>
	BOOL bRes;
	bRes	= CopyMembers( rStr );
	if( bRes==FALSE ){
		return *this;
	}

	// <<< Ԃ >>>
	return *this;
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr& operator=( const char* pStr )
//
//	[  ]
//		const char* pString			镶
//
//	[ ߂l ]
//		ւ̎Q
//
//	[  ]
//		Zq
//--------------------------------------------------------------------
CGStr& CGStr::operator=( const char* pStr )
{
	// <<<  >>>
	BOOL bRes;
	bRes	= Initialize();
	if( bRes==FALSE ){
		return *this;
	}

	// <<< ݒ >>>
	bRes	= SetString( pStr );
	if( bRes==FALSE ){
		return *this;
	}

	return *this;
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr	operator+( const CGStr& rString ) const
//
//	[  ]
//		const CGStr& rString		
//
//	[ ߂l ]
//		Ai[IuWFNg
//
//	[  ]
//		ZZq
//--------------------------------------------------------------------
CGStr	CGStr::operator+( const CGStr& rString ) const
{
	// <<< ʊi[pIuWFNg >>>
	CGStr	objStr;

	// <<< Z >>>
	objStr	= *this;
	objStr.AppendString( rString );

	return objStr;
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr operator+( const char* pString ) const
//
//	[  ]
//		const char* pString			鐔
//
//	[ ߂l ]
//		Ai[IuWFNg
//
//	[  ]
//		ZZq
//--------------------------------------------------------------------
CGStr	CGStr::operator+( const char* pString ) const
{
	// <<< ʊi[pIuWFNg >>>
	CGStr	objStr;

	// <<< Z >>>
	objStr	= *this;
	objStr.AppendString( pString );

	// <<< Ԃ >>>
	return objStr;
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr& operator+=( const char* pString )
//
//	[  ]
//		const char* pString			A镶
//
//	[ ߂l ]
//		ւ̎Q
//
//	[  ]
//		ZZq
//--------------------------------------------------------------------
CGStr& CGStr::operator+=( const char* pString )
{
	BOOL bRes;
	bRes	= AppendString( pString );
	return *this;
}


//--------------------------------------------------------------------
//	[  ]
//		CGStr& operaotr+=( const CGStr& rString )
//
//	[  ]
//		const CGStr& rString		A镶ւ̎Q
//
//	[ ߂l ]
//		ւ̎Q
//
//	[  ]
//		ZZq
//--------------------------------------------------------------------
CGStr& CGStr::operator+=( const CGStr& rString )
{
	BOOL bRes;
	bRes	= AppendString( rString );
	return *this;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL operator==( const char* pString ) const
//
//	[  ]
//		const char* pString			rΏۂ̕
//
//	[ ߂l ]
//		  vFTRUE
//		svFFALSE
//
//	[  ]
//		rZq
//		̓evĂꍇ TRUE Ԃ܂B
//		̊i[ʒuقȂĂĂA񂪈v
//		TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::operator==( const char* pString ) const
{
	// -----< NULL ꍇɂ >-----
	//
	if( pString==NULL ){
		if( GetString()!=NULL )return FALSE;
		return TRUE;
	}
	if( GetString()==NULL ){
		if( pString!=NULL )return FALSE;
		return TRUE;
	}

	// -----< ̕Ƃ NULL łȂꍇ >-----
	//
	if( strcmp( pString , GetString() )!=0 )return FALSE;
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL operator==( const CGStr& rString ) const
//
//	[  ]
//		const CGStr& rString		rΏƂ̕
//
//	[ ߂l ]
//		  vFTRUE
//		svFFALSE
//
//	[  ]
//		rZq
//		̓evĂꍇ TRUE Ԃ܂B
//		̊i[ʒuقȂĂĂA񂪈v
//		TRUE Ԃ܂B
//--------------------------------------------------------------------
BOOL CGStr::operator==( const CGStr& rString ) const
{
	// -----< NULL ꍇɂ >-----
	//
	if( rString.GetString()==NULL ){
		if( GetString()!=NULL )return FALSE;
		return TRUE;
	}
	if( GetString()==NULL ){
		if( rString.GetString()!=NULL )return FALSE;
		return TRUE;
	}

	// -----< ̕Ƃ NULL łȂꍇ >-----
	//
	if( strcmp( rString.GetString() , GetString() )!=0 )return FALSE;
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL operator!=( const char* pString ) const
//
//	[  ]
//		const char* pString			rΏƂ̕
//
//	[ ߂l ]
//		@vFFALSE
//		svFTRUE
//
//	[  ]
//		operator== ̔ےԂ܂B
//--------------------------------------------------------------------
BOOL CGStr::operator!=( const char* pString ) const
{
	BOOL bRes;
	bRes	= ( *this==pString );

	if( bRes==TRUE )return FALSE;
	return TRUE;
}


//--------------------------------------------------------------------
//	[  ]
//		BOOL operator!=( CGStr& rString ) const
//
//	[  ]
//		const CGStr& rString		rΏƂ̕
//
//	[ ߂l ]
//		@vFFALSE
//		svFTRUE
//
//	[  ]
//		operator== ̔ےԂ܂B
//--------------------------------------------------------------------
BOOL CGStr::operator!=( const CGStr& rString ) const
{
	BOOL bRes;
	bRes	= ( *this==rString );

	if( bRes==TRUE )return FALSE;
	return TRUE;
}
